# Web Cloud › Email and Collaborative Solutions › Microsoft 365 › Contract Signing API

> Part of the OVHcloud developer hub. Index of every page and section: https://developers.eu.ovhcloud.com/llms.txt
> The Web Cloud product's sections: https://developers.eu.ovhcloud.com/reference/web-cloud/llms.txt
> Everything in one file: https://developers.eu.ovhcloud.com/llms-full.txt

> 2 operations of the OVHcloud API. Calls carry `authorization: Bearer $OVH_TOKEN`; the EU host is shown, Canada and the United States answer on api.ca.ovhcloud.com and api.us.ovhcloud.com.

Page: https://developers.eu.ovhcloud.com/reference/web-cloud/email-and-collaborative-solutions/microsoft-365/contract-signing/

OpenAPI v1: https://api.eu.ovhcloud.com/1.0/__schemas/developer-hub-navigation/web-cloud/email-and-collaborative-solutions/microsoft-365/contract-signing.json?format=openapi3
OpenAPI v2: https://api.eu.ovhcloud.com/v2/__schemas/developer-hub-navigation/web-cloud/email-and-collaborative-solutions/microsoft-365/contract-signing.json?format=openapi3

## Operations

- `POST /license/officePrepaid/{serviceName}/parentTenant/createAttestation` — Create an MCA attestation
- `POST /license/officePrepaid/{serviceName}/parentTenant/acceptAgreement` — Accept the Microsoft Customer Agreement

## Create an MCA attestation

`POST /1.0/license/officePrepaid/{serviceName}/parentTenant/createAttestation`

Link: https://developers.eu.ovhcloud.com/reference/web-cloud/email-and-collaborative-solutions/microsoft-365/contract-signing/#post-license-officeprepaid-servicename-parenttenant-createattestation

**Status:** Alpha version  
**IAM actions:** `licenseOfficePrepaid:apiovh:createAttestation`

Creates a Microsoft Customer Agreement attestation for the parent tenant from the signatory company, names, email address, phone number, country and language. Returns the attestation ID and a link to the attestation that can be embedded in an iframe.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `serviceName` | path | string | yes | Service name |

### Request body (required)

Type: `license.officePrepaid.createAttestationPostPayload`

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `companyName` | string |  | Signatory company name |
| `country` | license.officePrepaid.CountryUppercaseEnum |  | Signatory Country — one of `AC`, `AD`, `AE`, `AF`, `AG`, `AI`, `AL`, `AM`, `AN`, `AO`, `AQ`, `AR`, … |
| `emailAddress` | string |  | Signatory email email address |
| `language` | nichandle.LanguageEnum |  | Signatory language — one of `cs_CZ`, `de_DE`, `en_AU`, `en_CA`, `en_GB`, `en_IE`, `en_US`, `es_ES`, `fi_FI`, `fr_CA`, `fr_FR`, `fr_MA`, … |
| `phoneNumber` | string |  | Signatory phone number |
| `signatoryFirstName` | string |  | Signatory first name |
| `signatoryLastName` | string |  | Signatory last name |

```json
{
  "companyName": "string",
  "country": "AC",
  "emailAddress": "string",
  "language": "cs_CZ",
  "phoneNumber": "string",
  "signatoryFirstName": "string",
  "signatoryLastName": "string"
}
```

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | license.officePrepaid.createAttestationResponse | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `attestationId` | string | read-only | Attestation id. |
| `attestationLink` | string | read-only | Link to iframable attestation |

```json
{
  "attestationId": "string",
  "attestationLink": "string"
}
```

### Example

```bash
curl -X POST \
  "https://api.eu.ovhcloud.com/1.0/license/officePrepaid/{serviceName}/parentTenant/createAttestation" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN" \
  -H "content-type: application/json" \
  -d '{ }'
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

# Request body type: license.officePrepaid.createAttestationPostPayload
result = client.post("/license/officePrepaid/{serviceName}/parentTenant/createAttestation",
	companyName = None, # Signatory company name (type: string)
	country = None, # Signatory Country (type: license.officePrepaid.CountryUppercaseEnum)
	emailAddress = None, # Signatory email email address (type: string)
	language = None, # Signatory language (type: nichandle.LanguageEnum)
	phoneNumber = None, # Signatory phone number (type: string)
	signatoryFirstName = None, # Signatory first name (type: string)
	signatoryLastName = None, # Signatory last name (type: string)
)

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

// Request body type: license.officePrepaid.createAttestationPostPayload
$result = $ovh->post("/license/officePrepaid/{serviceName}/parentTenant/createAttestation", array(
	companyName => null, // Signatory company name (type: string)
	country => null, // Signatory Country (type: license.officePrepaid.CountryUppercaseEnum)
	emailAddress => null, // Signatory email email address (type: string)
	language => null, // Signatory language (type: nichandle.LanguageEnum)
	phoneNumber => null, // Signatory phone number (type: string)
	signatoryFirstName => null, // Signatory first name (type: string)
	signatoryLastName => null, // Signatory last name (type: string)
));

print_r($result);
?>
```

## Accept the Microsoft Customer Agreement

`POST /1.0/license/officePrepaid/{serviceName}/parentTenant/acceptAgreement`

Link: https://developers.eu.ovhcloud.com/reference/web-cloud/email-and-collaborative-solutions/microsoft-365/contract-signing/#post-license-officeprepaid-servicename-parenttenant-acceptagreement

**Status:** Alpha version  
**IAM actions:** `licenseOfficePrepaid:apiovh:acceptAgreement`

Accepts the Microsoft Customer Agreement (MCA) for the parent tenant.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `serviceName` | path | string | yes | Service name |

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | — | successful operation |

### Example

```bash
curl -X POST \
  "https://api.eu.ovhcloud.com/1.0/license/officePrepaid/{serviceName}/parentTenant/acceptAgreement" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN"
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

result = client.post("/license/officePrepaid/{serviceName}/parentTenant/acceptAgreement")

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

$result = $ovh->post("/license/officePrepaid/{serviceName}/parentTenant/acceptAgreement");

print_r($result);
?>
```
